<?php

/**
 * @file
 * Contains \Drupal\photos\PhotosBreadcrumbBuilder.
 */

namespace Drupal\photos;

use Drupal\Core\Breadcrumb\BreadcrumbBuilderInterface;
use Drupal\Core\Breadcrumb\Breadcrumb;
use Drupal\Core\Routing\LinkGeneratorTrait;
use Drupal\Core\StringTranslation\StringTranslationTrait;
use Drupal\Core\Link;
use Drupal\Core\Routing\RouteMatchInterface;
use Drupal\Core\Session\AccountInterface;
use Drupal\node\NodeInterface;

class PhotosBreadcrumbBuilder implements BreadcrumbBuilderInterface {
  use StringTranslationTrait;

  /**
   * {@inheritdoc}
   */
  public function applies(RouteMatchInterface $route_match) {
    // @todo images and albums...
    // $route_match->getRouteName() == 'comment.reply'
    $fid = $route_match->getParameter('file');
    // @todo get file and image data.
    // drupal_set_message('Bread:' . print_r($file, 1), 'warning');
    $node = $route_match->getParameter('node');
    // @todo get node and album data.
    return $node instanceof NodeInterface && !empty($node->album);
  }

  /**
   * {@inheritdoc}
   */
  public function build(RouteMatchInterface $route_match) {
    $breadcrumb = new Breadcrumb();
    $breadcrumb->addCacheContexts(['route']);
    $breadcrumb->addLink(Link::createFromRoute($this->t('Home'), '<front>'));

    //$entity = $route_match->getParameter('entity');
    //$breadcrumb->addLink(new Link($entity->label(), $entity->urlInfo()));
    //$breadcrumb->addCacheableDependency($entity);
    // @todo https://www.drupal.org/node/2026025.
    /*
    if ($v) {
      $url = Url::fromUri('base:/');
      $b[] = \Drupal::l(t('Home'), $url);

      foreach ($v as $t) {
        $b[] = $t;
      }
    }
    else {
      foreach (\Drupal::service('breadcrumb')->getLinks() as $t) {
        $b[] = $t;
      }
      $b[] = \Drupal::service('title_resolver')->getTitle(\Drupal::request(), \Drupal::routeMatch()->getRouteObject());
    }

    return \Drupal::service('breadcrumb')->setLinks($b);
    */
    // @todo update for photos.
    if (($pid = $route_match->getParameter('pid')) && ($comment = $this->storage->load($pid))) {
      /** @var \Drupal\comment\CommentInterface $comment */
      $breadcrumb->addCacheableDependency($comment);
      // Display link to parent comment.
      // @todo Clean-up permalink in https://www.drupal.org/node/2198041
      $breadcrumb->addLink(new Link($comment->getSubject(), $comment->urlInfo()));
    }

    return $breadcrumb;
  }

}
